/**********************************************************************************************/
/* VDK_BLOB.h																				  */
/*                                                                       					  */
/* Valentina SDK    																		  */
/*                                                                       					  */
/* Copyright Paradigma, 1993-2002															  */
/* All Rights Reserved                                                   					  */
/**********************************************************************************************/

#ifndef __VDK_BLOB_h 
	#define __VDK_BLOB_h
	
#if VSDK_FRAMEWORK_STYLE
#	include <VSDK/VDK_Field.h>
#else
#	include <VDK_Field.h>
#endif // VSDK_FRAMEWORK_STYLE

#if defined(__MWERKS__)
	#pragma options align=power
#endif


/**********************************************************************************************/
class FBL_EXP VDK_BLOB : public virtual VDK_Field
{
		friend class VDK_BaseObject;

	public://///////////////////////////////////////////////////////////////////////////////////
		
							 	// inSegmentSize will be used only once - 
								// on create of blob file. It can't be changed runtime. 
FBL_EXP							VDK_BLOB( 
									const char* inName, 
									ulong		inSegmentSize = 10 * 1024	);	

								// Returns the size of the data in the current BLOB
FBL_EXP virtual ulong			GetDataSize( void ) const;
		
								// Adds a new BLOB record and store its reference in this field.
FBL_EXP	virtual void			WriteBLOBData( const char* inBuffer, ulong inBytes, ulong inFrom = 0 );

								// Deletes a BLOB-record, reference in the table record become NULL. 
FBL_EXP	virtual void			DeleteBLOBData( void );

								// Reads from the disk to the buffer an accociated BLOB record if any.
								// Returns number of bytes actually readed.
FBL_EXP	virtual ulong			ReadBLOBData( char* inBuffer, ulong inBytes, ulong inFrom = 0 ) const;

								// Set the length of the BLOB record.
FBL_EXP	virtual void			SetBLOBLength( ulong inNewLength );
		
		// Disk file storing:
		
								// Restore from BLOB disk file into specified location. 
FBL_EXP	virtual void 			RestoreDiskFile( FILE_PATH* inFile );
		
								// Store disk file at specified location into BLOB field.
FBL_EXP	virtual void 			StoreDiskFile( FILE_PATH* inFile );
	
		// Accessories:
		
		ulong					GetSegmentSize( void )  const { return mSegmentSize; }

								// Must be inited before the database files are created.
FBL_EXP	void					SetSegmentSize( 
									ulong		inSegmentSize = 1 * 1024,
									bool		inSaveOnDisk = true );
								

	protected://////////////////////////////////////////////////////////////////////////////////

FBL_EXP virtual void			FinishCreateSelf( void );

	protected://////////////////////////////////////////////////////////////////////////////////

		ulong					mSegmentSize;

}; 


/**********************************************************************************************/
#if defined(__MWERKS__)
	#pragma options align=reset
#endif

#endif  


